%define DISTDIR	/opt

Summary: Mozilla Firefox Web Browser
Name: firefox
Version: 3.0.4
Release: b1
License: MPL/LGPL
Group: Applications/Internet
Source: %{name}-%{version}.tar.bz2
Source1: firefox-rebuild-databases.pl.in
Source2: firefox.desktop
URL: http://www.mozilla.org/projects/firefox/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArchitectures: i686
NoSource: 0

%description
Mozilla Firefox is an open-source web browser, designed for standards
compliance, performance and portability.


%prep
rm -rf $RPM_BUILD_ROOT
%setup -c -q
#rm libnss3.so libnssckbi.so libplc4.so libplds4.so libsmime3.so
#rm libsoftokn3.* libssl3.so
# libraries provide mozilla-nss,nspr
#rm firefox-bin.elf
#ln -s firefox-bin firefox-bin.elf
rm firefox/{README.txt,removed-files,old-homepage-default.properties}

%{__cat} <<EOF >bookmarks.html
<!DOCTYPE NETSCAPE-Bookmark-file-1>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<TITLE>Bookmarks</TITLE>
<H1>Bookmarks</H1>

<DL><p>
	<DT><H3 PERSONAL_TOOLBAR_FOLDER="true" ID="NC:PersonalToolbarFolder">Personal Toolbar Folder</H3>
	<DL><p>
	<DT><A HREF="http://berry.homeunix.org/">Berry Linux</A>
	<DT><A HREF="http://www.google.com/">Google</A>
	<DT><A HREF="http://www.yahoo.com/">Yahoo!</A>
	<DT><A FEEDURL="http://www.nytimes.com/services/xml/rss/nyt/HomePage.xml">Newyork Times</A>
	<DT><A HREF="http://yui.mine.nu/whiz/whiz.html">Whiz Openlab</A>
	<DT><A HREF="http://www.yahoo.co.jp/">Yahoo! Japan</A>
	<DT><A FEEDURL="http://weather.livedoor.com/forecast/rss/index.xml">天気予報</A>
	<DT><A FEEDURL="http://feeds.asahi.com/asahi/TopHeadlines">朝日新聞</A>
	<DT><A FEEDURL="http://www.usfl.com/rss/usfl.rdf">U.S. FrontLine</A>
	</DL><p>
	<HR>
</DL><p>
EOF

%{__cat} <<'EOF' >firefox.sh
#!/bin/sh
MOZILLA_FIVE_HOME="%{DISTDIR}/firefox"
MOZ_PROGRAM="$MOZILLA_FIVE_HOME/firefox"

LD_LIBRARY_PATH="$MOZILLA_FIVE_HOME:$MOZILLA_FIVE_HOME/plugins:$LD_LIBRARY_PATH"
MOZ_PLUGIN_PATH="$MOZILLA_FIVE_HOME/plugins:%{_libdir}/mozilla/plugins:$MOZ_PLUGIN_PATH"
FONTCONFIG_PATH="/etc/fonts:$MOZILLA_FIVE_HOME/res/Xft"
export MOZILLA_FIVE_HOME LD_LIBRARY_PATH MOZ_PLUGIN_PATH FONTCONFIG_PATH

MOZARGS=""
MOZLOCALE="$(echo $LANG | sed 's|_\([^.]*\).*|-\1|g')"
if [ -f "$MOZILLA_FIVE_HOME/chrome/$MOZLOCALE.jar" ]; then
	MOZARGS="-UILocale $MOZLOCALE"
fi

$MOZ_PROGRAM -a firefox -remote 'ping()' &>/dev/null
RUNNING=$?
if [ $? -eq 2 ]; then RUNNING=0; fi

CMD=0
while [ "$1" ]; do
	case "$1" in
#	  -mail|-email)
#		if [ $RUNNING -eq 0 -a $CMD -ne 1 ]; then
#			MOZARGS="-remote xfeDoCommand(openInbox) $MOZARGS"
#			CMD=1
#		fi;;
#	  -compose|-editor)
#		if [ $RUNNING -eq 0 -a $CMD -ne 1 ]; then
#			MOZARGS="-remote xfeDoCommand(composeMessage) $MOZARGS"
#			CMD=1
#		fi;;
	  -remote)
		if [ $CMD -ne 1 ]; then
			MOZARGS="-remote $2 $MOZARGS"
			CMD=1
		fi
		shift;;
	  -profile|-profile-manager)
		CMD=1
		;;
	  -*)
		MOZARGS="$MOZARGS $1"
		;;
	  *)
		if [ $CMD -ne 1 ]; then
			if [ -e "$PWD/$1" ]; then
				URL="file://$PWD/$1"
			elif [ -e "$1" ]; then
				URL="file://$1"
			else
				URL="$1"
			fi
			if [ $RUNNING -eq 0 ]; then
				MOZARGS="-remote openURL(\"$URL\",new-window) $MOZARGS"
			else
				MOZARGS="-remote openURL(\"$URL\") $MOZARGS"
			fi
			CMD=1
		else
			MOZARGS="$MOZARGS $1"
		fi;;
	esac
	shift
done

if [ $RUNNING -eq 0 -a $CMD -ne 1 ]; then
	exec $MOZ_PROGRAM -a firefox -remote "xfeDoCommand(openBrowser)" $MOZARGS
else
	exec $MOZ_PROGRAM -a firefox $MOZARGS &
fi;
EOF


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{DISTDIR}/firefox
cp -a firefox/* $RPM_BUILD_ROOT%{DISTDIR}/firefox

%{__install} -D -m0755 firefox.sh %{buildroot}%{_bindir}/firefox
#%{__install} -D -m0644 %{SOURCE2} %{buildroot}%{_datadir}/pixmaps/firefox.png

%{__install} -m0644 bookmarks.html %{buildroot}%{DISTDIR}/firefox/defaults/profile/
##%{__install} -m0644 bookmarks.html %{buildroot}%{DISTDIR}/firefox/defaults/profile/US/

%{__install} -D -m0755 %{SOURCE1} %{buildroot}%{DISTDIR}/firefox/firefox-rebuild-databases.pl
%{__perl} -pi -e 's|\$MOZ_DIST_BIN|%{DISTDIR}/firefox|g;' %{buildroot}%{DISTDIR}/firefox/firefox-rebuild-databases.pl

mkdir -p %{buildroot}/usr/share/applications/
%{__install} -m0644 %{SOURCE2} %{buildroot}/usr/share/applications/

cat >> %{buildroot}%{DISTDIR}/%{name}/defaults/pref/firefox.js << EOM

pref("browser.sessionhistory.max_total_viewers", 2);
pref("browser.cache.memory.capacity", 8192);
EOM


%post
/sbin/ldconfig 2>/dev/null
%{DISTDIR}/firefox/firefox-rebuild-databases.pl &>/dev/null || :

### Work around for creating extensions directory
unset DISPLAY
%{DISTDIR}/firefox/firefox --help &>/dev/null || :

#pushd %{DISTDIR}/firefox/
#for library in lib*.so; do
#	if [ -e /usr/lib/${library} ]; then
#		rm %{DISTDIR}/firefox/${library}
#	else
#		ln -s %{DISTDIR}/firefox/${library} /usr/lib/${library}
#	fi
#done
#popd

%postun
/sbin/ldconfig 2>/dev/null
if [ $1 -gt 1 ]; then
	%{DISTDIR}/firefox/firefox-rebuild-databases.pl &>/dev/null || :
fi
#for f in /usr/lib/*; do
#	[ -f "$f" -a ! -s "$f" ] && rm "$f"
#done

%preun
if [ $1 -eq 0 ]; then
	%{__rm} -rf %{DISTDIR}/firefox/{chrome/overlayinfo/,components/}
	%{__rm} -f %{DISTDIR}/firefox/chrome/*.rdf
fi

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root, 0755)
%{_bindir}/firefox
/opt/firefox
/usr/share/applications/


%changelog
* Mon Nov 24 2008 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 3.0.4
* Sat Sep 27 2008 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 3.0.3
* Fri Jun 20 2008 Yuichiro Nakada <berry@po.yui.mine.nu>
- Update to 3.0
* Tue Jul 20 2004 Yuichiro Nakada <berry@po.yui.mine.nu>
- Create for Berry Linux
